/*
 * find_F.c
 *
 *  Created on: Jan 18, 2023
 *      Author: ron
 */

#include <stdio.h>
#include <string.h>
#include "find_F.h"
#include <ctype.h>
#include <stdlib.h>

#define FAIL 0
#define PASS 1


#define max_F_len 120
char genFormula[max_F_len + 10];
char oldFormula[max_F_len + 12];
char tmpStr[max_F_len + 12];
#define symblNumTblLen 100 //max number of chars in formula
int symblNumTbl[symblNumTblLen]; //symblNumTbl[0] is the number for the first symbol in the formula
#define maxSymblCount 12

char *next_try(unsigned char reset);
unsigned char preTest(char *test_F);
char *addConstant(char *test_F, int constNum);
char *addFunct(char *test_F, int functNum);
unsigned char recoverSymbolNumTbl(char *);
void addToNumTbl(int num);
int numTblPos;
void tblToFormula(char *genFormula);
void incsymblNumTbl(void);
void printSymblNumTbl(void);
int isFunctName(char *str, char *strPtr);

#define qtyOfConstants 19
char *constantTbl[qtyOfConstants]=
{
		"1.0E-13",
		"pi",
		"e",
		"loge",
		"log2e",
		"log10e",
		"ln2",
		"6.62607015E−34", // planck constant
		"1.602176634E-19", //elementary charge
		"6.67430E-11", // G
		"1.25663706212E−6", //vacuum magnetic permeability
		"7.2973525693E−3", //fine structure constant
		"1E-2",
		"1",
		"100",
		"10000",
		"299792458", //c
		"8.8541878128E12", //vacuum electric permitivity
		"9.1093837015E31", //electron mass
};
int presConstantNum;
#define qtyOfFuncts 31
char *functTbl[qtyOfFuncts]=
{
		"exp",
		"log",
		"sqrt",
		"sin",
		"cos",
		"tan",
		"cot",
		"sec",
		"csc",
		"asin",
		"acos",
		"atan",
		"acot",
		"asec",
		"acsc",
		"sinh",
		"cosh",
		"tanh",
		"coth",
		"sech",
		"csch",
		"asinh",
		"acosh",
		"atanh",
		"acoth",
		"asech",
		"acsch",
		"abs",
		"step",
		"delta",
		"nandelta"
};
int presFunctNum;




char test_F[max_F_len];

char *gen_F(unsigned char reset, char *startF) //------------------------------------------------------------------
{
 unsigned char valid_F;
 char *tmpChPtr;
 int isOk;
 int i;
 int len;

 test_F[0] = '\0';
	if(reset == 1)
 {

	 //int i;
	//	for(i = 0; i < 200; i++)
	//	{
	//	 incsymblNumTbl();
 //  printSymblNumTbl();
	//	}
	//	exit(0);

		oldFormula[0] = '\0';
		presConstantNum = 0;
		presFunctNum = 0;
		next_try(1);
		return &test_F[0];
 }
	if(reset == 2)
 {
		oldFormula[0] = '\0';
		presConstantNum = 0;
		presFunctNum = 0;
		isOk = recoverSymbolNumTbl(startF);
		if(isOk == 0)
		{
   printSymblNumTbl();
		}
		tblToFormula(test_F);
  strcpy(oldFormula, test_F);
  tmpChPtr = strchr(oldFormula, 'n');
  if(tmpChPtr != NULL)	 presConstantNum = 1;
 	printf("recovered formula: %s\n", test_F);
		return test_F;
 }

	if(presFunctNum != 0) //if need to add a function
	{
		tmpChPtr = addFunct(oldFormula, presFunctNum);
	 strcpy(test_F, tmpChPtr);
	 if((presConstantNum == 0)&&(++presFunctNum >= qtyOfFuncts))
	 {
	 	presFunctNum = 0;
	 }
	 if(presConstantNum == 0)  //there will only be one constant per formula for now
	 {
	  tmpChPtr = strchr(oldFormula, 'n');
	 	if(tmpChPtr != NULL) //if need to add a constant
	 		presConstantNum = 1;
	 }
		if(presConstantNum != 0) //if need to add a constant
		{
			tmpChPtr = addConstant(oldFormula, presConstantNum);
		 strcpy(test_F, tmpChPtr);
		 if(++presConstantNum >= qtyOfConstants)
		 {
		 	presConstantNum = 0;
		 }
		}
	 len = strlen(test_F);
	 for(i = 0; i < len; i++)
	 {
	  if ((test_F[i] == 'n')&&(isFunctName(test_F, &test_F[i]) == 0))
	  {
	  	test_F[i] = '1';
	  }
	 }
	 return test_F;
	}  //there will only be one constant per formula for now
	if(presConstantNum != 0) //if need to add a constant
	{
		tmpChPtr = addConstant(oldFormula, presConstantNum);
	 strcpy(test_F, tmpChPtr);
	 if(++presConstantNum >= qtyOfConstants)
	 {
	 	presConstantNum = 0;
	 }
	 return test_F;
	}
	valid_F = FAIL;
	while(valid_F == FAIL)
	{
		strcpy(test_F, next_try(0));

  if(strcmp(test_F, oldFormula) != 0) // don't return same formula twice
   valid_F = preTest(test_F);
	}
 strcpy(oldFormula, test_F);
 tmpChPtr = strchr(oldFormula, 'n');
	if(tmpChPtr != NULL) //if need to add a constant
	{
	 presConstantNum = 0;
	 tmpChPtr = addConstant(test_F, presConstantNum);
		strcpy(test_F, tmpChPtr);
	 presConstantNum = 1;
	} //there will only be one constant per formula, all others will
	  // be replaced with a '1'
 len = strlen(test_F);
 for(i = 0; i < len; i++)
 {
  if ((test_F[i] == 'n')&&(isFunctName(test_F, &test_F[i]) == 0))
  {
  	test_F[i] = '1';
  }
 }
 tmpChPtr = strchr(oldFormula, '(');
	if(tmpChPtr != NULL) //if need to add a funct
	{ //first one is just '(' with no funct
	 presFunctNum = 1;
	}
 return test_F;
}
//---------------------------------------------------------------
int isFunctName(char *str, char *strPtr)
{
 int j;

 for(int i = 0; i < qtyOfFuncts; i++)
 {
 	int len = strlen(functTbl[i]);
 	char *posMin = strPtr;
 	j = 0;
 	while((posMin != str)&&(j < len)) // only check the occurance near strPtr
 	{
 		--posMin;
 		++j;
 	}
  char *pos = strstr(posMin, functTbl[i]);
 	char *posF = functTbl[i]; //only test the nearest occurance
  while((pos != NULL)&&(*pos == *posF))
  {
   if (*pos == *strPtr)
   {
    return 1;
   }
   ++pos;
   ++posF;
  }
 }
 return 0;
}
//---------------------------------------------------------------
void printSymblNumTbl(void)
{
	int i;

 for(i = 0; (i < symblNumTblLen)&&(symblNumTbl[i] != 0); i++)
 {
 	printf("%d, ", symblNumTbl[i]);
 	if((i != 0)&&(i % 25 == 0))
 		printf("\n");
 }
 printf("\n");
}
//---------------------------------------------------------------
//return 1 for success
unsigned char recoverSymbolNumTbl(char *startF)
{
	int i;
	char *startF_ptr;
	unsigned char testR;

	startF_ptr = startF;

	numTblPos = 0;
	for(i = 0; (*startF_ptr != '\0')&&(i < max_F_len); i++, ++startF_ptr)
	{
		if(isdigit(*startF_ptr)) //if char is the beginning of a number
		{
		 for(;(*startF_ptr != '\0')&&(i < max_F_len); i++, ++startF_ptr)
		 {
		 	if(isdigit(*startF_ptr)) continue;
	  	testR = 0;
		 	switch(*startF_ptr)
		 	{
		 	 case '.': //chars that are part of a number
		 	 	testR = 1;
		 	 	break;
		 	 case 'E':
		 	 case 'e'://inside on a number, 22E-10
      if((*(startF_ptr+1) == '-')||(*(startF_ptr+1) == '+'))
      {
     	 ++i;
     	 ++startF_ptr;
      }
		 	 	testR = 1;
		 	 	break;
		 	 default:
			  	testR = 0;
		 	}
		 	if(testR == 0) break; //end of the number
		 }
  	addToNumTbl(5); //numbers are expanded from 'n'
	 }
		switch(*startF_ptr)
		{
   case '\0': //---- end of symbols in formula
	  	return 1;
   	break;
   case 'M': //---- next symbol
   	addToNumTbl(1);
  	 break;
	  case 'V': //---- next symbol
   	addToNumTbl(2);
	  	break;
	  case 'm': //---- next symbol
   	addToNumTbl(3);
	  	break;
	  case 'v': //---- next symbol
   	addToNumTbl(4);
	  	break;
	  case 'n': //---- next symbol
   	addToNumTbl(5);
	  	break;
	  case '+': //---- next symbol
   	addToNumTbl(6);
	  	break;
	  case '-': //---- next symbol
   	addToNumTbl(7);
	  	break;
	  case '*': //---- next symbol
   	addToNumTbl(8);
	  	break;
	  case '/': //---- next symbol
   	addToNumTbl(9);
	  	break;
	  case '(': //---- next symbol
   	addToNumTbl(10);
	  	break;
	  case ')': //---- next symbol
   	addToNumTbl(11);
	  	break;
	  case 'N': //---- next symbol
   	addToNumTbl(12);
	  	break;
	  case 'p': //---- next symbol
	  	++startF_ptr;
	 	 if(*startF_ptr == 'i')
  	  addToNumTbl(5); //was expanded from 'n'
	 	 else
		  	return 0;
	 	 break;
	  case 'e': //---- next symbol
 	  addToNumTbl(5); //was expanded from 'n'
	  	break;
	  case 'l':
	  	if((*(startF_ptr+1) == 'o')&&(*(startF_ptr+2) == 'g')) // log
	  	{
	  		startF_ptr += 2;
	  		i += 2;
	  		if(*(startF_ptr+1) == 'e') //loge
	  		{
	  			++startF_ptr;
	  			++i;
	   	 addToNumTbl(5); //was expanded from 'n'
	  	 	break;
	  		}
	  		if((*(startF_ptr+1) == '2')&&(*(startF_ptr+2) == 'e')) //log2e
	  		{
		  		startF_ptr += 2;
		  		i += 2;
	   	 addToNumTbl(5); //was expanded from 'n'
	  	 	break;
	  		}
	  		if((*(startF_ptr+1) == '1')&&
	  				 (*(startF_ptr+2) == '0')&&
		 					(*(startF_ptr+3) == 'e')) //log10e
	  		{
		  		startF_ptr += 3;
		  		i += 3;
	   	 addToNumTbl(5); //was expanded from 'n'
	  	 	break;
	  		}
	 	 }
	 	 if((*(startF_ptr+1) == 'n')&&(*(startF_ptr+2) == '2')) // ln2
	 	 {
	 	 	startF_ptr += 2;
	 	 	i += 2;
  	  addToNumTbl(5); //was expanded from 'n'
 	  	break;
	 	 }
	 	 break;
	  default: // the number of case in this switch should be = to maxSymblCount
	 	 return 0;
		}
	}
	return 1;
}
void addToNumTbl(int num)
{
	symblNumTbl[numTblPos] = num;
	if(++numTblPos >= symblNumTblLen)
	{
		printf("symbolNumTbl is full\n");
		exit(0);
	}
}
//---------------------------------------------------------------
char *addConstant(char *test_F, int constNum)
{
 char temp[120];   // Create a temporary string to store the end of the original string
 char *pos;

 tmpStr[0] = 'n';
 tmpStr[1] = '\0';
 if((presConstantNum >= qtyOfConstants)||(constantTbl[constNum] == NULL))
 {
		printf("addConstant failed. test_F = %s presConstantNum = %d\n", test_F, presConstantNum);
		exit(0);
 }
	if((strlen(test_F) + strlen(constantTbl[constNum])) >= max_F_len)
 {
		printf("addConstant failed. test_F = %s presConstantNum = %d\n", test_F, presConstantNum);
		exit(0);
 }

	strcpy(tmpStr, test_F);

 pos = strchr(tmpStr, 'n');
 if((pos != NULL)&&(*pos != '\0'))
 {
  strcpy(temp, pos+1);

     // Replace the character 'n' with the constant at index constNum
  *pos = '\0';
  strcat(tmpStr, constantTbl[constNum]);
  strcat(tmpStr, temp);
 }

	return tmpStr;
}
//---------------------------------------------------------------
char *addFunct(char *test_F, int functNum)
{
 char temp[120];   // Create a temporary string to store the end of the original string
 char *pos;

 tmpStr[0] = 'n';
 tmpStr[1] = '\0';
 if((presFunctNum >= qtyOfFuncts)||(functTbl[functNum] == NULL))
 {
		printf("addFunct failed. test_F = %s presFunctNum = %d\n", test_F, presFunctNum);
		exit(0);
 }
	if((strlen(test_F) + strlen(functTbl[functNum])) >= max_F_len)
 {
		printf("addFunct failed. test_F = %s presFunctNum = %d\n", test_F, presFunctNum);
		exit(0);
 }

	strcpy(tmpStr, test_F);

 pos = strchr(tmpStr, '(');
 if((pos != NULL)&&(*pos != '\0'))
 {
  strcpy(temp, pos);

     // add the funct before the character '(' with the constant at index constNum
  *pos = '\0';
  strcat(tmpStr, functTbl[functNum]);
  strcat(tmpStr, temp);
 }

	return tmpStr;
}
//---------------------------------------------------------------
char *next_try(unsigned char reset)
{
 int i;

	if(reset == 1)
	{
		for(i=0; i < symblNumTblLen; i++) symblNumTbl[i] = 0;
		genFormula[0] = '\0';
		return genFormula;
	}

	incsymblNumTbl();

	genFormula[0] = '\0';
	tblToFormula(genFormula);
	return genFormula;
}
//--------------------------------------------------------------------------
void incsymblNumTbl(void)
{
 int i, j;

	for(i=0; i < (symblNumTblLen - 1); i++) //increment (like a number where the the base is symblCount)
	{
		if(symblNumTbl[i] >= maxSymblCount)
		{
	  //1 is the first symbol, 0 = no symbol = no more symbols to put into formula
			//++symblNumTbl[i+1];
			for(j = i; j != 0; j--)
			{
				symblNumTbl[j] = 1;
			}
			symblNumTbl[0] = 1;
		}
		else
		{
			++symblNumTbl[i];
			break;
		}
	}
}
//--------------------------------------------------------------------------
void tblToFormula(char *genFormula)
{
	int i;
	for(i=0; i < symblNumTblLen; i++) //generate the formula
	{
		switch(symblNumTbl[i])
		{
	  case 0: //---- end of symbols in formula
		 	return;
	  	break;
	  case 1: //---- next symbol
	 	 strcat(genFormula, "M"); //constant
	 	 break;
 	 case 2: //---- next symbol
 	 	strcat(genFormula, "V"); //center mass
 	 	break;
 	 case 3: //---- next symbol
 	 	strcat(genFormula, "m"); //center velocity
 	 	break;
 	 case 4: //---- next symbol
 	 	strcat(genFormula, "v"); //mass of voxel beyond face
 	 	break;
 	 case 5: //---- next symbol
 	 	strcat(genFormula, "n"); //velocity of voxel beyond face
 	 	break;
		 case 6: //---- next symbol
		 	strcat(genFormula, "+");
		 	break;
		 case 7: //---- next symbol
		 	strcat(genFormula, "-");
		 	break;
		 case 8: //---- next symbol
		 	strcat(genFormula, "*");
		 	break;
		 case 9: //---- next symbol
		 	strcat(genFormula, "/");
		 	break;
		 case 10: //---- next symbol
		 	strcat(genFormula, "(");
		 	break;
		 case 11: //---- next symbol
		 	strcat(genFormula, ")");
		 	break;
		 case 12: //---- next symbol
		 	strcat(genFormula, "N");
		 	break;
		// case 12: //---- end of symbols in formula
		// 	return genFormula;
		// 	break;
		 default: // the number of case in this switch should be = to maxSymblCount
		  strcpy(genFormula, "Error");
		 	return;
		}
	}
	if(i == symblNumTblLen)
	{
		strcpy(genFormula, "Done");
		exit(1);
	}
}
//--------------------------------------------------------------------------
unsigned char preTest(char *test_F)
{
 int i;
 unsigned char openParen, closeParen;
 char *tmpChr;
 char var_M, var_m, var_V, var_v;

 openParen = 0;
 closeParen = 0;

 var_M = var_m = var_V = var_v = 0; //all of these variables must be in formula

  switch(*test_F)
  {
	  case '+':
	  case '-':
	  case '*':
	  case '/':
	   return FAIL; //fail if operator is first char in the formula
	  	break;
 }

 for(i = 0; (i < max_F_len)&&(test_F[i] != '\0'); i++)
 {
  switch(test_F[i])
  {
  	case 'm':
  		var_m = 1;
	  	break;
  	case 'M':
  		var_M = 1;
	  	break;
  	case 'v':
  		var_v = 1;
	  	break;
  	case 'V':
  		var_V = 1;
	  	break;
  }
  switch(test_F[i])
  {
	  case '(':
	   ++openParen;
	   tmpChr = &test_F[i+1];
	   switch(*tmpChr)
	   {
	    case '\0':
     case '+':
     case '-':
     case '*':
     case '/':
     case ')': // fail if empty parentheses
  	   return FAIL; //fail if operator right after open parentheses
     	break;
    }
	   ++tmpChr;
	   if(*tmpChr == '\0') break;
	   if(*tmpChr == ')') return FAIL; // fail if only one thing in parentheses
	   ++tmpChr;
	   if(*tmpChr == '\0') break;
	   if(*tmpChr == ')') return FAIL; // fail if only two things in parentheses
	   break;
	  case ')':
	   ++closeParen;
	   if(closeParen > openParen) return FAIL; // fail if too many close parentheses
	  	if(i != 0)
	  	{
		   switch(test_F[i-1])
		   {
	     case '+':
	     case '-':
	     case '*':
	     case '/':
	  	   return FAIL; //fail if operator right before close parentheses
	     	break;
	    }
	  	}
	 	 break;
   case '+':
   case '-':
   case '*':
   case '/':
    switch(test_F[i+1])
    {
     case '\0':
      return FAIL; //fail if operator is last char in formula
  	  case '+':
  	  case '-':
  	  case '*':
  	  case '/':
      return FAIL; //fail if two operators in a row
	   }
    break;
  	case 'n':
  	case 'N':
  	case 'm':
  	case 'M':
  	case 'v':
  	case 'V':
  	 switch(test_F[i+1])
  	 {
  	  case '\0':
  	  	break;
   	 case 'n':
   	 case 'N':
   	 case 'm':
   	 case 'M':
   	 case 'v':
   	 case 'V':
	     return FAIL; //fail if two constants or variables in a row
  	 }
  	 break;
  	}
 }
 if(openParen != 0)
 {
  if(openParen != closeParen)
   return FAIL; //fail if unmatched parentheses
  for(i = 0; (i < max_F_len)&&(test_F[i] != '\0'); i++)
  {
  	if((test_F[i] == '(')&&(i != 0))
  	{
  		switch(test_F[i-1])
  		{
  	  case 'n':
  	  case 'N':
  	  case 'm':
  	  case 'M':
  	  case 'v':
  	  case 'V':
      return FAIL; //fail if constant before (, like 3(...)
  	  default:
  	  	break;
  		}
  	}
  	if(test_F[i] == ')')
  	{
  		switch(test_F[i+1])
  		{
  	  case 'n':
  	  case 'N':
  	  case 'm':
  	  case 'M':
  	  case 'v':
  	  case 'V':
      return FAIL; //fail if constant after ), like (...)3
  	  default:
  	  	break;
  		}
  	}
  }
 }
 if((var_M == 0) ||
 		 (var_m == 0) ||
				(var_V == 0) ||
				(var_v == 0)
			)
  return FAIL; //fail if not all variables present

 return PASS;
}





