

/*
     GenF
     Ronald J Heath 2023
     www.rhwebco.com

The purpose of this program is to generate all possible combinations of symbols that can be expressed as a valid math formula (limited to certain symbols and without calculus). The formulas will be put into text files in comma delimited format. The program will fill up one text file, then create the next filename in the sequence, as defined by the numbers at the end of the filename (example: formulas_001.txt to formulas_XXX.txt). The program can be re-started from the last generated formula, so that the first n files need not be regenerated.

*/



#include <stdio.h>
#include "find_F.h"
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>


#define numCols 7

#define numberOfFormulasPerFile 10000
#define numberOfFiles 20

int main(int argc, char** argv)
{
	int i,j;
	char *next_F;
	char filename[120];
 int nFilesIndx;
// if (argc < 2)
// {
//  printf("Usage: %s [argument]\n", argv[0]);
//  return 1;
// }
// char *arg = argv[1];
 if (argc == 2)
 {
  char *arg = argv[1];
  printf("have formula to start at: %s\n", arg);
  next_F = gen_F(2, arg); //reset symbol table to start at given formula
 	if(strcmp(next_F, "error") == 0)
 	{
 		printf("failed to parse given formula\n");
 		return 0;
 	}
 }
 else
 {
	 gen_F(1, NULL); //reset symbol table
 }

 for(nFilesIndx = 0; nFilesIndx < numberOfFiles; nFilesIndx++)
 {

  // Get file name
  i = 1;
  sprintf(filename, "formulas_%03d.txt", i);
  struct stat st;
  for(i = 1; i < 1000; i++)
  {
   sprintf(filename, "formulas_%03d.txt", i);
   if (stat(filename, &st) == -1) break;
  }
  if(i == 1000)
  {
  	printf("no more filenames, last was: %s\n", filename);
   return 0;
  }
	 printf("filename is: %s\n", filename);



  FILE *fp = fopen(filename, "a");
  if (fp == NULL)
  {
   printf("Could not open file\n");
   return 0;
  }

  for(i=0; i < numberOfFormulasPerFile; i++)
  {
  	for(j=0; j < numCols; j++)
  	{
  		next_F = gen_F(0, NULL);//get the next formula
  //	 printf("%s, ", next_F);
    // Append text to the file
    fprintf(fp, "%s, ", next_F);
	  }
 //  printf("\n");
   fprintf(fp, "\n");
  }
//  printf("\n");
  fprintf(fp, "\n");
  // Close the file
  if (fclose(fp) != 0)
  {
   printf("Could not close file formulas.txt\n");
   return 0;
  }
 }

	printf("\nDone\n");

	return 0;
}
