

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include <sys/stat.h>
#include <assert.h>
#include <dirent.h>
#include <sys/ipc.h>
#include <signal.h>
#include <time.h>


#include <sys/ipc.h>
#include <sys/shm.h>
//gcc your_program.c -o your_program -lrt


void sigint_handler(int signum);

#define 	base_key 1000

#define numberOfClients 50
#define sharedMemSize 1000
#define maxFormulaChars sharedMemSize/2-4

typedef struct
{
	int shm_id;
	key_t key;
	char *shm_ptr;
	int active;
	char lastFormulaM[maxFormulaChars];
	char lastFormulaV[maxFormulaChars];
} clientInfo;
clientInfo clientInfoArr[numberOfClients];

void closeAndFree(clientInfo *clientArray);





#define maxNames 100
#define maxNameChars 120

int presFileNumM, presFileNumV;
int presFormulaNumM, presFormulaNumV;
long totalFormulas;
int startFileNumM, startFileNumV;
int startFormulaNumM, startFormulaNumV;
int dataFileNum;


char filenames[maxNames][maxNameChars];
int numFiles;
FILE *current_fileM = NULL;
FILE *current_fileV = NULL;
char current_formulaM[maxFormulaChars];
char current_formulaV[maxFormulaChars];
int presFormulaInLineM;
int presFormulaInLineV;
char presFormulaLineM[maxFormulaChars];
char presFormulaLineV[maxFormulaChars];
char presFormulaM[maxFormulaChars];
char presFormulaV[maxFormulaChars];


char *getNextFormulaLineM(int option);
char *getNextFormulaLineV(int option);
char *getNextFormulaM(int option);
char *getNextFormulaV(int option);
int endsWithNewLine(char *str);
int getFileNames(void);
int compare_filenames(const void *a, const void *b);
void sortFileNames(char filenames[][maxNameChars], int numFiles);
void logAppend(char *addLine);
int isStop(void);
void rmNewline(char *str);
void appendBest(char *formulaM, char *formulaV);
long int memLeft(void);










void usage(void)
{
	// if no args, start at file 0, formula 0 for both M and V
	// if argc = 2:
	// ./testAlgoOneD_01 3,4,5,6
	// M will start at file 3, formula 4 and V will start at file 5, formula 6
	printf("\n---------------------------------------------------\n");
	printf("if no args, both M and V will start at file = 0, formula = 0\n");
	printf("if arg is present, example:\n");
	printf(" ./testAlgoOneD_01 3,4,5,6,7,8\n");
	printf(" M will start at file 3, formula 4 and V will start at file 5, formula 6\n");
	printf("The total formulas processed will start at 7, numPassed will start at 8");
	printf("\n");
}

//------------------------------------------------------------------------------------
// if no args, start at file 0, formula 0 for both M and V
// if argc = 2:
// ./testAlgoOneD_01 3,4,5,6
// M will start at file 3, formula 4 and V will start at file 5, formula 6
//------------------------------------------------------------------------------------

int main(int argc, char** argv)//--------------------------------------------
{
	int i;
	key_t key;
	char tmpSysCmd[120];
	char tmpLogStr[sharedMemSize + 120];
 time_t t = time(NULL);
 struct tm tm;
 int processAssigned;


 // Register the 'SIGINT' signal handler
 signal(SIGINT, sigint_handler);

 printf("testAlgoMain with %d background processes. Press Ctrl+C to exit.\n", numberOfClients);

 presFormulaInLineM = 0;
 presFormulaInLineV = 0;
 presFormulaLineM[0] = '\0';
 presFormulaLineV[0] = '\0';
 presFormulaM[0] = '\0';
 presFormulaV[0] = '\0';

 startFileNumM = startFileNumV = 0;
 startFormulaNumM = startFormulaNumV = 0;

 dataFileNum = 0;

 numFiles = getFileNames();
 sortFileNames(filenames, numFiles);

 printf("Found %d files:\n", numFiles);
 for(i = 0; i < numFiles; i++)
 {
  printf("%s\n", filenames[i]);
 }
 printf("\n");
 presFileNumM = presFileNumV = 0;
 presFormulaNumM = presFormulaNumV = 0;
 totalFormulas = 0;
 long int numPassed = 0;

/*
 //-******************************** DEBUG ***********************
 getNextFormulaV(2);
 for(i = 0; i < 22; i++)
 {
  printf("formula V number %d = %s\n", i, getNextFormulaV(0));

 }
 exit(0);
 //-******************************** END DEBUG ***********************
*/
 tm = *localtime(&t);
 sprintf(tmpLogStr, "Started new run: y%04dm%02dd%02d %02d:%02d:%02d\n",
        tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
        tm.tm_hour, tm.tm_min, tm.tm_sec);

 logAppend(tmpLogStr);

 if (argc == 2)//initial start values present, ./testAlgoOneD_01 3,4,5,6
 {             // startFileNumM, startFormulaNumM, startFileNumV, startFormulaNumV
 	char *arg;
 	char *tmpChPtr;

  arg = argv[1];
  printf("received: %s\n", arg);
  tmpChPtr = strtok(arg, ",");
  if(tmpChPtr == NULL)
  {
 		printf("\n*********\ncould not parse startFileNumM\n");
  	usage();
  	return 0;
  }
  startFileNumM = atoi(tmpChPtr);
  tmpChPtr = strtok(NULL, ",");
  if((tmpChPtr == NULL)||(startFileNumM >= numFiles))
  {
 		printf("\n*********\ncould not parse startFormulaNumM, or startFileNumM > numFiles\n");
  	usage();
  	return 0;
  }
  startFormulaNumM = atoi(tmpChPtr);
  tmpChPtr = strtok(NULL, ",");
  if(tmpChPtr == NULL)
  {
 		printf("\n*********\ncould not parse startFileNumV\n");
  	usage();
  	return 0;
  }
  startFileNumV = atoi(tmpChPtr);
  tmpChPtr = strtok(NULL, ",");
  if((tmpChPtr == NULL)||(startFileNumV >= numFiles))
  {
 		printf("\n*********\ncould not parse startFileNumV, or startFileNumV > numFiles\n");
  	usage();
  	return 0;
  }
  startFormulaNumV = atoi(tmpChPtr);


  tmpChPtr = strtok(NULL, ",");
  if(tmpChPtr == NULL)
  {
 		printf("\n*********\ncould not parse total formulas processed\n");
  	usage();
  	return 0;
  }
  totalFormulas = atol(tmpChPtr);

  tmpChPtr = strtok(NULL, ",");
  if(tmpChPtr == NULL)
  {
 		printf("\n*********\ncould not parse total number passed\n");
  	usage();
  	return 0;
  }
  numPassed = atol(tmpChPtr);

  printf("startFileNumM = %d, startFormulaNumM = %d, startFileNumV = %d, startFormulaNumV = %d, totalFormulas = %ld, numPassed = %ld\n",
  		      startFileNumM, startFormulaNumM, startFileNumV, startFormulaNumV, totalFormulas, numPassed
  		    );
  getNextFormulaM(2);
  getNextFormulaV(2);
  presFileNumM = startFileNumM;
  presFileNumV = startFileNumV;

  for(i = 0; i < startFormulaNumM; i++)
  {
  	char *tmpChPtr;

  	tmpChPtr = getNextFormulaM(0);
  	if(tmpChPtr == NULL)
  	{
  		printf("\n*********\nrequested startFormulaNumM, %d, returned NULL\n", startFormulaNumM);
  		usage();
  		return 0;
  	}
  }
  for(i = 0; i < startFormulaNumV; i++)
  {
  	char *tmpChPtr;

  	tmpChPtr = getNextFormulaV(0);
  	if(tmpChPtr == NULL)
  	{
  		printf("\n*********\nrequested startFormulaNumV, %d, returned NULL\n", startFormulaNumV);
  		usage();
  		return 0;
  	}
  }
 }
 sprintf(tmpLogStr, "startFileNumM = %d, startFormulaNumM = %d, startFileNumV = %d, startFormulaNumV = %d\n",
 		      startFileNumM, startFormulaNumM, startFileNumV, startFormulaNumV
 		     );
 logAppend(tmpLogStr);
 printf("%s", tmpLogStr);


 //get shared memory for each client, then start up a process for each client
	key = base_key;
	for(i = 0; i < numberOfClients; i++, key++)
	{
		clientInfoArr[i].key = key; //get shared memory ID
		clientInfoArr[i].shm_id = shmget(key, sharedMemSize, IPC_CREAT | 0660);
		// 0660 sets read/write permissions for the owner and group
  if(clientInfoArr[i].shm_id < 0)
  {
  	printf("Error: could not get shm_id with shmget() for key = %d\n", key);
  	exit(1);
  } //get shared memory pointer
  clientInfoArr[i].shm_ptr = shmat(clientInfoArr[i].shm_id, NULL, 0);
  if(clientInfoArr[i].shm_ptr == (char*)-1)
  {
  	printf("Error: could not get shm_ptr with shmmat() for key = %d\n", key);
  	exit(1);
  }
  //strcpy(clientInfoArr[i].shm_ptr, "x");
  strcpy(clientInfoArr[i].lastFormulaM, "M+m+V+v"); //initial formula
  strcpy(clientInfoArr[i].lastFormulaV, "M+m+V+v"); //initial formula
  strcpy(clientInfoArr[i].shm_ptr, "x,M+m+V+v,M+m+V+v");
  sprintf(tmpSysCmd, "sudo ./testAlgoClient %d &", key);
  *clientInfoArr[i].shm_ptr = 'r'; //send the "start processing" command
  printf("\rstarting background process testAlgoClient with key = %d\n", key);
  fflush(stdout);  // Flush the output buffer to ensure the message is printed immediately
  system(tmpSysCmd);
  clientInfoArr[i].active = 1;
	}

 char *tmpChPtrM;
 char *tmpChPtrV;
 char *tmpCliCmdPtr;
 char tmpCliCmdBuf[maxFormulaChars];
 int score;
	//int j = 0;
	int k = 0;

	time_t startTime1, startTime2, startTime3, currentTime;
 time(&startTime1);  // Get the current time as the start time
 time(&startTime2);  // Get the current time as the start time
 time(&startTime3);  // Get the current time as the start time
 int softTimer01 = 1;  // Set the time between checking if stop file exists
 int softTimer02 = 10;  // Set the time out to N seconds for log updates
 int softTimer03 = 10;  // Set the time out to N seconds for log updates
 long int memLeftL;
#define memTooLow 32000000

 memLeftL =  memLeft();

 while((tmpChPtrM = getNextFormulaM(0)) != NULL) //------------------- main Loop
 {
 	if(isStop())
 	{
 		printf("*** stop.txt file detected, Exiting. ***");
 		break;
 	}
 	if(memLeftL < memTooLow) break;
  while((tmpChPtrV = getNextFormulaV(0)) != NULL) // time to check if stop file exists
  {
  	time(&currentTime);  // Get the current time
  	if(difftime(currentTime, startTime1) >= softTimer01)
  	{
    	if(isStop()) break;
    	memLeftL =  memLeft(); //check if memory is getting too low
    	if(memLeftL < memTooLow)
    	{
    		t = time(NULL);
    		tm = *localtime(&t);
    		 sprintf(tmpLogStr, "**** Memory too low: y%04dm%02dd%02d %02d:%02d:%02d Exiting ****\n",
    		        tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
    		        tm.tm_hour, tm.tm_min, tm.tm_sec);
      logAppend(tmpLogStr);
      printf("%s", tmpLogStr);
    		break;
    	}
     time(&startTime1);  // Get new start time
  	}

   if(difftime(currentTime, startTime2) >= softTimer02) //time for log update
   {
  	 sprintf(tmpLogStr, "log. M = %s, V = %s, fileM = %d, formulaM = %d, fileNumV = %d, formulaNumV = %d, total = %ld, numPassed = %ld\n",
            tmpChPtrM, tmpChPtrV, presFileNumM, presFormulaNumM, presFileNumV, presFormulaNumV, totalFormulas, numPassed
		  	      );
    logAppend(tmpLogStr);
    printf("%s", tmpLogStr);
    time(&startTime2);  // Get new start time
   }

   time(&startTime3);  // Get new start time for assign time out
   processAssigned = 0;
   while(processAssigned == 0)
   {
   	time(&currentTime);  // Get the current time
    if(difftime(currentTime, startTime3) >= softTimer03)
    {
    	printf("----- time out waiting for assign -----\n");
    	break; //time out
    }
    for(i = 0; (i < numberOfClients)&&(processAssigned == 0); i++)
    {
     if((*clientInfoArr[i].shm_ptr != 'r')&&(*clientInfoArr[i].shm_ptr != 't')) //if client has updated since last "start processing" command
     {
     	if(*clientInfoArr[i].shm_ptr == 's') //if score is greater than zero
     	{
     		tmpCliCmdPtr = clientInfoArr[i].shm_ptr;
     		++tmpCliCmdPtr; //at ','
     		++tmpCliCmdPtr; //at beginning of score
      	tmpCliCmdBuf[0] = '\0';
       for(k = 0; (k < 5)&&(*tmpCliCmdPtr != '\0'); k++, tmpCliCmdPtr++)
       {
       	tmpCliCmdBuf[k] = *tmpCliCmdPtr;
       	tmpCliCmdBuf[k + 1] = '\0';
       	if((*tmpCliCmdPtr == '\n')||(*tmpCliCmdPtr == ','))
       	{
       		tmpCliCmdBuf[k] = '\0';
       	 break;
       	}
       }
     		score = atoi(tmpCliCmdBuf);
     		++numPassed;
      	sprintf(tmpLogStr, "*** score = %d ***, M = %s, V = %s, process key = %d\n",
               score, clientInfoArr[i].lastFormulaM, clientInfoArr[i].lastFormulaV, clientInfoArr[i].key
    		 	      );
       //logAppend(tmpLogStr);
       appendBest(clientInfoArr[i].lastFormulaM, clientInfoArr[i].lastFormulaV);
       printf("%s", tmpLogStr);
     	}
      sprintf(clientInfoArr[i].shm_ptr, "x,%s,%s", tmpChPtrM, tmpChPtrV);
      strcpy(clientInfoArr[i].lastFormulaM, tmpChPtrM);
      strcpy(clientInfoArr[i].lastFormulaV, tmpChPtrV);
     	if(totalFormulas == 500)
     	{
       *clientInfoArr[i].shm_ptr = 't'; //send the "test" command
     	}
     	else
     	{
       *clientInfoArr[i].shm_ptr = 'r'; //send the "start processing" command
     	}
      processAssigned = 1;
      ++totalFormulas;
     }
  	 }
   }
  }
  getNextFormulaV(2);
 }
 printf("all done.\n");

 sleep(3);
 closeAndFree(&clientInfoArr[0]);
 return 0;
}
// Function to handle the 'SIGINT' signal
void sigint_handler(int signum) //--------------------------------------------
{
 printf("Received SIGINT (Ctrl+C). Now closing all processes.\n");
 closeAndFree(&clientInfoArr[0]);
 printf("Exiting...\n");
 exit(0);
}
void closeAndFree(clientInfo *clientArray) //--------------------------------------------
{
	key_t key;
	int i;
	int allExited;
	time_t startTime, currentTime;
	int softTimer01;

	getNextFormulaLineM(2); //close the formula files
	getNextFormulaLineV(2);

	key = base_key;
	for(i = 0; i < numberOfClients; i++, key++) //send kill command to clients
	{
  *clientInfoArr[i].shm_ptr = 'k'; //send the "kill" command
	}
 sleep(2);
 //send exit command to each client then free the shared memory for each client.
 time(&startTime);  // Get the current time as the start time
 softTimer01 = 5 + numberOfClients;  // Set the time out to N seconds
 key = base_key;
	allExited = 0;
 while(allExited == 0)
 {
 	allExited = 1;
 	for(i = 0; i < numberOfClients; i++, key++) //check all clients
 	{
   if(clientInfoArr[i].active == 0) continue;
 	 if(strcmp(clientArray[i].shm_ptr, "exit\n") == 0)
		 {
	   printf("\rreceived exit confirmation from client %d\n", key);
    fflush(stdout);  // Flush the output buffer to ensure the message is printed immediately
	   shmdt(clientArray[i].shm_ptr); //detach pointer to shared memory
	   clientInfoArr[i].active = 0;
		 }
		 else
		 {
		 	allExited = 0;
		 }
 	}
 	time(&currentTime);  // Get the current time
  if (difftime(currentTime, startTime) >= softTimer01)
  {
      printf("Timer expired! Exiting the loop\n");
      break;
  }
  sleep(1);
 }
 printf("\rall clients stopped and all shared memory freed. Exiting\n");
 exit(0);
}
int compare_filenames(const void *a, const void *b)
{
	//char tmpStr1[maxNameChars], tmpStr2[maxNameChars];
	//char *tmpChPtr;

    const char *filename1 = *(const char **)a;
    const char *filename2 = *(const char **)b;
    int num1 = atoi(filename1 + strlen("formulas_"));
    int num2 = atoi(filename2 + strlen("formulas_"));
    return num1 - num2;
}
//-----------------------------------------------------------------------------
void sortFileNames(char filenames[][maxNameChars], int numFiles) {
    // Create an array of pointers to the filenames
    const char **filename_ptrs = malloc(numFiles * sizeof(char *));
    for (int i = 0; i < numFiles; i++) {
        filename_ptrs[i] = filenames[i];
    }

    // Use qsort to sort the array of pointers
    qsort(filename_ptrs, numFiles, sizeof(char *), compare_filenames);

    // Create a temporary array to hold the sorted filenames
    char sorted_filenames[maxNames][maxNameChars];

    // Copy the sorted filenames into the temporary array
    for (int i = 0; i < numFiles; i++) {
        strncpy(sorted_filenames[i], filename_ptrs[i], maxNameChars-1);
        sorted_filenames[i][maxNameChars-1] = '\0';
    }

    // Copy the sorted filenames back into the original array
    for (int i = 0; i < numFiles; i++) {
        strncpy(filenames[i], sorted_filenames[i], maxNameChars-1);
        filenames[i][maxNameChars-1] = '\0';
    }

    // Free the array of pointers
    free(filename_ptrs);
}

//-----------------------------------------------------------------------------
//get the names of all files in present directory
//that begin with "formulas", same as: ls formulas*.*
int getFileNames(void)
{
    DIR *dir;
    struct dirent *ent;
    int numFiles = 0;
    char prefix[] = "formulas";

    // Open current directory
    if ((dir = opendir(".")) != NULL) {

        // Loop through all files in directory
        while ((ent = readdir(dir)) != NULL && numFiles < maxNames) {

            // Check if filename starts with "formulas"
            if (strncmp(prefix, ent->d_name, strlen(prefix)) == 0) {

                // Copy filename into filenames array
                strncpy(filenames[numFiles], ent->d_name, maxNameChars-1);
                filenames[numFiles][maxNameChars-1] = '\0';

                numFiles++;
            }
        }
        closedir(dir);
    }

    return numFiles;
}

//-----------------------------------------------------------------------------
char *getNextFormulaM(int option)
{
	int i;
	char *tmpChPtr;
	char tmpPresLine[maxFormulaChars];

	if(option == 1)
	{
		getNextFormulaLineM(1);
		return NULL;
	}
	if(option == 2)
	{
		presFormulaInLineM = 0;
		getNextFormulaLineM(2);
		return NULL;
	}

	if(strlen(presFormulaLineM) < 4) presFormulaInLineM = 0; //no more formulas in the line from the file
	if(presFormulaInLineM == 0)
	{
		tmpChPtr = getNextFormulaLineM(0);
		if(tmpChPtr == NULL) return NULL;
		strcpy(presFormulaLineM, tmpChPtr);
		presFormulaInLineM = 1;
	}
	strcpy(tmpPresLine, presFormulaLineM);
	for(i = 0; i < presFormulaInLineM; i++)
	{
		if(i == 0)
		{
			tmpChPtr = strtok(tmpPresLine, ",");
		}
		else
		{
			tmpChPtr = strtok(NULL, ",");
		}
		presFormulaM[0] = '\0';
		if(tmpChPtr == NULL) break;
  while((*tmpChPtr != '\0')&&(*tmpChPtr == ' ')) ++tmpChPtr; //leading spaces
		if((*tmpChPtr == '\0')||(*tmpChPtr == '\r')||(*tmpChPtr == '\n'))
		{
			break;
		}
	 strcpy(presFormulaM, tmpChPtr);
  for(tmpChPtr = presFormulaM;*tmpChPtr != '\0'; ++tmpChPtr) //trailing spaces and newline
  {
  	if((*tmpChPtr == ' ')||(*tmpChPtr == '\r')||(*tmpChPtr == '\n'))
  		*tmpChPtr = '\0';
  }
	}
	++presFormulaInLineM;
 if((presFormulaM[0] == '\0')||(presFormulaM[0] == ','))
 {
 	presFormulaInLineM = 0;
 	return(getNextFormulaM(0));
 	//return NULL;
 }
 ++presFormulaNumM;
 return presFormulaM;
}
//-----------------------------------------------------------------------------
char *getNextFormulaV(int option)
{
	int i;
	char *tmpChPtr;
	char tmpPresLine[maxFormulaChars];

	if(option == 1)
	{
		getNextFormulaLineV(2);
		return NULL;
	}
	if(option == 2)
	{
		presFormulaInLineV = 0;
		getNextFormulaLineV(2);
		return NULL;
	}

	if(strlen(presFormulaLineV) < 4) presFormulaInLineV = 0; //no more formulas in the line from the file
	if(presFormulaInLineV == 0)
	{
		tmpChPtr = getNextFormulaLineV(0);
		if(tmpChPtr == NULL)
		{
			getNextFormulaLineV(2);
			return NULL; //no more lines
		}
		strcpy(presFormulaLineV, tmpChPtr);
		presFormulaInLineV = 1;
	}
	strcpy(tmpPresLine, presFormulaLineV);
	for(i = 0; i < presFormulaInLineV; i++)
	{
		if(i == 0)
		{
			tmpChPtr = strtok(tmpPresLine, ",");
		}
		else
		{
			tmpChPtr = strtok(NULL, ",");
		}
		presFormulaV[0] = '\0';
		if(tmpChPtr == NULL) break;
  while((*tmpChPtr != '\0')&&(*tmpChPtr == ' ')) ++tmpChPtr; //leading spaces
  if((*tmpChPtr == '\0')||(*tmpChPtr == '\r')||(*tmpChPtr == '\n')) break;
	 strcpy(presFormulaV, tmpChPtr);
  for(tmpChPtr = presFormulaV;*tmpChPtr != '\0'; ++tmpChPtr) //trailing spaces and newline
  {
  	if((*tmpChPtr == ' ')||(*tmpChPtr == '\r')||(*tmpChPtr == '\n'))
  		*tmpChPtr = '\0';
  }
	}
	++presFormulaInLineV;
 if((presFormulaV[0] == '\0')||(presFormulaV[0] == ','))
 {
 	presFormulaInLineV = 0;
 	return(getNextFormulaV(0));
  //return NULL;
 }
 ++presFormulaNumV;
 return presFormulaV;
}
//-----------------------------------------------------------------------------
char *getNextFormulaLineM(int option)
{


 if(option == 1)
 {
 	if(current_fileM != NULL)
 	{
 		fclose(current_fileM);
 	}
 	return NULL;
 }
 if(option == 2)
 {
 	if(current_fileM != NULL)
 	{
 		fclose(current_fileM);
 		current_fileM = NULL;
 	}
 	presFileNumM = 0;
 	return NULL;
 }
 // If we haven't opened a file yet, open the first file in the list
 if (current_fileM == NULL)
 {
 	printf("getNextFormulaLineM() open first file, filename = %s\n", filenames[presFileNumM]);
  if(presFileNumM >= numFiles) return NULL; //no more files
  current_fileM = fopen(filenames[presFileNumM], "r");
  if (current_fileM == NULL)
  {
   perror("Error opening file");
   return NULL;
  }
  presFormulaNumM = 0;
 }

    // Read the next line from the current file
    while (fgets(current_formulaM, maxFormulaChars, current_fileM) != NULL)
    {
     // If the line starts with a comma, it's not a formula
    	// if the line starts with \n, it is a blank line
     if((current_formulaM[0] == ',')||(current_formulaM[0] == '\n')||(current_formulaV[0] == '\r'))
     {
      continue;
     }
 //printf("line from M = %s\n", current_formulaM);
     // Return the formula
     return current_formulaM;
    }

    // If we've reached the end of the current file, close it and move on to the next file
    fclose(current_fileM);
    current_fileM = NULL;
    presFormulaNumM = 0;

    // If there are no more files, return NULL to indicate that we're done
    // Open the next file in the list
    if(++presFileNumM >= numFiles) return NULL; // no more files
    current_fileM = fopen(filenames[presFileNumM], "r");
    if(current_fileM == NULL)
    {
        perror("Error opening file");
        return NULL;
    }


    // Read the first formula from the new file
    if (fgets(current_formulaM, maxFormulaChars, current_fileM) != NULL) {
        return current_formulaM;
    }

    // If the new file is empty, recursively call getNextFormulaLineM() to move on to the next file
    return getNextFormulaLineM(0);
    //return NULL;
}


//-----------------------------------------------------------------------------
char *getNextFormulaLineV(int option)
{

	 if(option == 1)
	 {
	 	if(current_fileV != NULL)
	 	{
	 		fclose(current_fileV);
	 		current_fileV = NULL;
	 	}
	 	return NULL;
	 }
	 if(option == 2)
	 {
	 	if(current_fileV != NULL)
	 	{
	 		fclose(current_fileV);
	 		current_fileV = NULL;
	 	}
	 	presFormulaNumV = 0;
	 	presFileNumV = 0;
	 	return NULL;
	 }


	 // open the first file in the list
    if (current_fileV == NULL)
    {
    	if(presFileNumV >= numFiles) return NULL; //no more files
     current_fileV = fopen(filenames[presFileNumV], "r");
    	presFormulaNumV = 0;
   //  printf("getNextFormulaLineV() open first file, filename = %s\n",filenames[presFileNumV]);
     if (current_fileV == NULL)
     {
      perror("Error opening file");
      return NULL;
     }
    }

    // Read the next line from the current file
    while (fgets(current_formulaV, maxFormulaChars, current_fileV) != NULL)
    {
     // If the line starts with a comma, it's not a formula
    	// if the line starts with \n, it is a blank line
     if((current_formulaV[0] == ',')||(current_formulaV[0] == '\n')||(current_formulaV[0] == '\r'))
     {
      continue;
     }
     // Return the formula
     return current_formulaV;
    }

    // If we've reached the end of the current file, close it and move on to the next file
    fclose(current_fileV);
    current_fileV = NULL;
 	 	presFormulaNumV = 0;


    // If there are no more files, return NULL to indicate that we're done
    // Open the next file in the list
    if(++presFileNumV >= numFiles)
    {
    	presFileNumV = 0;
    	return NULL; // no more files
    }
    current_fileV = fopen(filenames[presFileNumV], "r");
    if (current_fileV == NULL) {
        perror("Error opening file");
        return NULL;
    }


    // Read the first formula from the new file
    if (fgets(current_formulaV, maxFormulaChars, current_fileV) != NULL) {
        return current_formulaV;
    }

    // If the new file is empty, recursively call getNextFormulaLineV() to move on to the next file
    return getNextFormulaLineV(0);
    //return NULL;

}

//-----------------------------------------------------------------------------
void logAppend(char *addLine)
{
 FILE *fp;

 // Open the file for appending
 fp = fopen("logfile.txt", "a");
 if (fp == NULL) {
     printf("Error opening logfile\n");
     return;
 }

 // Write a line of text to the file
 if(endsWithNewLine(addLine))
 	fprintf(fp, "%s", addLine);
 else
 	fprintf(fp, "%s\n", addLine);

 // Close the file
 fclose(fp);

 return;
}
//-----------------------------------------------------------------------------
int endsWithNewLine(char *str) {
    int len = strlen(str);
    if (len > 0 && strcmp(&str[len-1], "\n") == 0) {
        return 1;
    }
    return 0;
}
//-----------------------------------------------------------------------------
// returns 1 if the file stop.txt exists
int isStop(void) {
    if (access("stop.txt", F_OK) == 0) {
        // The file "stop.txt" exists in the current directory
        return 1;
    } else {
        // The file "stop.txt" does not exist
        return 0;
    }
}
//-----------------------------------------------------------------------------
void appendBest(char *formulaM, char *formulaV)
{
 FILE *fp;

 // Open the file for appending
 fp = fopen("best.txt", "a");
 if (fp == NULL) {
     printf("Error opening best file\n");
     return;
 }

 // Write a line of text to the file
 if(endsWithNewLine(formulaM))
 	rmNewline(formulaM);

 if(endsWithNewLine(formulaV))
 	fprintf(fp, "M = %s, V = %s", formulaM, formulaV);
 else
 	fprintf(fp, "M = %s, V = %s\n", formulaM, formulaV);

 // Close the file
 fclose(fp);

 return;
}
//-----------------------------------------------------------------------------
void rmNewline(char *str)
{
 int len = strlen(str);
 int i;
 char *tmpStr;

 for(i = 0, tmpStr = str; i < len; i++, tmpStr++)
 {
 	if(*tmpStr == '\n') *tmpStr = ' ';
 }
}
long int memLeft(void) //----------------------------------------------------------------
{
 int found;

 FILE *meminfo = fopen("/proc/meminfo", "r");
 if (meminfo == NULL)
 {
  perror("Failed to open /proc/meminfo");
  return 0;
 }

 char line[256];
 long int free_memory = 0;

 found = 0;
 while ((fgets(line, sizeof(line), meminfo))&&(found == 0))
 {
  if (sscanf(line, "MemFree: %ld kB", &free_memory) == 1)
  {
   found = 1;   // Found free memory information
  }
 }
 fclose(meminfo);
 return free_memory;
}

